#include "ConfigurationVariableStreamer_v1.h"
#include "../ConfigurationVariable.h"


namespace SctData {
namespace IO {

/* READ NOTES ON STREAMERS AND VERSIONS BEFORE EDITING THIS FILE! */
unsigned ConfigurationVariableStreamer_v1::s_version=1;
	
bool ConfigurationVariableStreamer_v1::inMap = IOManager::addToMap("SctData::ConfigurationVariable",  std::auto_ptr<Streamer>(new ConfigurationVariableStreamer_v1()));    
ConfigurationVariableStreamer_v1::ConfigurationVariableStreamer_v1() throw() {}

void ConfigurationVariableStreamer_v1::write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
  const ConfigurationVariable& var = dynamic_cast<const ConfigurationVariable&>(ob);
  out << ConfigurationVariableIOHelper::getTypeRep(var);
}

shared_ptr<Streamable> ConfigurationVariableStreamer_v1::read(IStream& in, const IOManager& manager) const throw(LogicError, IoError) {
    unsigned short rep = 0;
    in >> rep;
    return ConfigurationVariableIOHelper::getFromTypeRep(rep);
}

void ConfigurationVariableStreamer_v1::read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
    ///@todo throw Sct::LogicError("Unsupported operation in ConfigurationVariableIS", MRS_ERROR, "libSctDataIS");
}

}
}
