#include <list>
#include <utility>

#include "SctApiFwd.h"

namespace SctApi {
class RodInfo {
 public:
  /// Minimum link which is configured to receive data
  int minLink;

  /// Which modules have their redundant TTC provided by another ROD
  /**
     The key is the mid on this ROD (ch < 48)
   */
  std::map<unsigned long, unsigned long> offRODTTC;

  /// Which modules have their RX on another ROD
  /*
    Key is mid on this ROD (ch >= 48)
   */
  std::map<unsigned long, unsigned long> offRODRX;

  RodInfo() : minLink(97) {}
};
}
