package ProdDatabase;
import java.sql.*;
import java.util.*;

public class ShipmentInfo  {
   Statement statement;
   ResultSet resultSet;
   StringBuffer sqlStat;
   Vector shipmentList;
   SCTDBInterface db;

   public ShipmentInfo() {
      db = SCTDBInterface.getInstance();
      shipmentList=new Vector();
   }

//***********************************************************************
    public Vector getShipmentVector() {
           return shipmentList;
    }
// ****************************************************************************************************************
    public String getitemsinShipment(String locn,String sn1,String sn2,boolean onlyBarCodes) throws Exception {
// Add items to table from sn1 to sn2 located at locn

      if(onlyBarCodes) shipmentList = new Vector();

      sqlStat = new StringBuffer("SELECT ");
      sqlStat.append("ser_no,ctype,assembled FROM items");
      sqlStat.append(" WHERE locn_name LIKE '"+locn+"' AND ser_no >= "+sn1+" AND ser_no <= "+sn2);
      sqlStat.append(" ORDER BY ser_no");

      statement = db.connection.createStatement();
     System.out.println("Checking your ownership of items from "+sn1+" to "+sn2+" ...");
     resultSet = statement.executeQuery(sqlStat.toString());
     int recordCount=0;
     int itemcount=0;
     String ctype=null;
     for(boolean n = resultSet.next() ; n==true ; n=resultSet.next() ){
          recordCount++;

          String serno = resultSet.getString(1);
          if(ctype==null) ctype = resultSet.getString(2);
          String assembledFlag = resultSet.getString(3);
// must use the bmModule or bmSB serial numbers only
          if(ctype.equals("bmHASIC") && onlyBarCodes) { 
               System.out.println(serno+" is invalid. Please use the barcode number!!!");
               break; 
               }
          if(ctype.equals("bmHPC") && onlyBarCodes) {
               System.out.println(serno+" is invalid. Please use the barcode number!!!");
               break;
               }
          if(ctype.equals("bmBB") && onlyBarCodes) {
               System.out.println(serno+" is invalid. Please use the barcode number!!!");
               break;
               } 
// if they are assembled, don't ship them separately     
          if(ctype.equals("bmHASIC") && assembledFlag.equals("YES")) continue;
          if(ctype.equals("bmHPC") && assembledFlag.equals("YES")) continue;
          if(ctype.equals("bmBB") && assembledFlag.equals("YES")) continue;
// ok add them to the shipment
          Vector theLine = new Vector();
          theLine.addElement(serno);   // serial no
          theLine.addElement(ctype);   // type
          theLine.addElement(assembledFlag);   // assembled flag
          if(!shipmentList.contains((Vector)theLine)) shipmentList.addElement(theLine);
          itemcount++;
	    }
      System.out.println("Retrieved "+recordCount+" records in total, and validated your ownership of "+itemcount);
      statement.close();
      return ctype;
      }
}

